// TradeKeys.h : main header file for the TRADEKEYS application
//

// TradeKeys Version 2.0
// Copyright  2003 Ziff Davis Media, Inc. All rights reserved.
// First published in PC Magazine, US Edition, January 14, 2003.
// Written by Gregory A. Wolking

#if !defined(AFX_TRADEKEYS_H__1132F316_1CA2_4EA7_B2E2_5D59C1B1D5BD__INCLUDED_)
#define AFX_TRADEKEYS_H__1132F316_1CA2_4EA7_B2E2_5D59C1B1D5BD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

// #defines for access to VKEYMAP.VXD
#ifndef CTL_CODE
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method))
#endif

#ifndef FILE_DEVICE_KEYBOARD
#define FILE_DEVICE_KEYBOARD   0x0000000b
#endif

#ifndef METHOD_BUFFERED
#define METHOD_BUFFERED                 0
#endif

#ifndef FILE_ANY_ACCESS
#define FILE_ANY_ACCESS                 0
#endif

#define	SS_NumLock		0x0020
#define	VXD_KEY		"System\\CurrentControlSet\\Services\\VxD\\VKeyMap"
#define	VXD_NAME	"VKEYMAP"
#define IOCTL_NEW_MAPPINGS CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0100, METHOD_BUFFERED, FILE_ANY_ACCESS)

// Data structures.
typedef struct
{
	WORD	wScanCode;
	char	*pszName;
} MASTER_TABLE_ENTRY;

typedef struct
{
	WORD wOldCode;
	WORD wNewCode;
	int	iColor;
	char *pszOldName;
	char *pszNewName;
} MAP_ARRAY_ENTRY, *LPMAP_ARRAY_ENTRY;

// Enum type used by file-mapping functions.
enum FILE_MAP_STATUS
{
	MAP_FAILED,
	MAP_FIRST,
	MAP_SECOND
};

// Structure used for file-mapped data.
typedef struct 
{
	HWND hWndMain;
	char pszFileName[MAX_PATH];
} MY_SHARED_DATA, *LPMY_SHARED_DATA;

#define TRADEKEYS_VERIFY_ID			(WM_APP + 5)	// Used to make sure we have the right window.
#define TRADEKEYS_OPEN_FILE			(WM_APP + 6)
#define TRADEKEYS_APP_ID			0xBADDCABBL

/////////////////////////////////////////////////////////////////////////////
// CTradeKeysApp:
// See TradeKeys.cpp for the implementation of this class
//

class CTradeKeysApp : public CWinApp
{
public:
	CString m_strSettingSection;
	CTradeKeysApp();
	LPMY_SHARED_DATA		m_pSharedData;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTradeKeysApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CTradeKeysApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	HANDLE					m_hMappedData;
	enum FILE_MAP_STATUS	Init_Mapped_Data(void);
	int m_intMinToColumnWidth;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRADEKEYS_H__1132F316_1CA2_4EA7_B2E2_5D59C1B1D5BD__INCLUDED_)
