// TradeKeysDlg.cpp : implementation file
//

// TradeKeys Version 2.0
// Copyright  2003 Ziff Davis Media, Inc. All rights reserved.
// First published in PC Magazine, US Edition, January 14, 2003.
// Written by Gregory A. Wolking

#include "stdafx.h"
#include "TradeKeys.h"
#include "TradeKeysDlg.h"
#include "WarnDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Globals

// Our one and only application object.
extern CTradeKeysApp theApp;

// Key map table and data for the Win 9x VxD
UCHAR	g_KeyMappings[256];
HANDLE	hVxD;		// VxD handle.
BOOL	g_bIsNT;	// NT flag.


// Master list of "official" scan codes and key names for
// a standard 102-key US keyboard, including the newer
// Windows Logo and Menu keys, in the order that the keys are most
// likely to be reassigned.
MASTER_TABLE_ENTRY g_MasterTable [TOTAL_MAP_ENTRIES] =
{
	{0x00, "<Disabled>"},
	{0x2A, "Left Shift"},
	{0x36, "Right Shift"},
	{0x1D, "Left Ctrl"},
	{0xE01D, "Right Ctrl"},
	{0x38, "Left Alt"},
	{0xE038, "Right Alt"},
	{0xE05B, "Left Windows"},
	{0xE05C, "Right Windows"},
	{0xE05D, "Menu"},
	{0xE052, "Insert"},
	{0xE053, "Delete"},
	{0xE047, "Home"},
	{0xE04F, "End"},
	{0xE049, "Page Up"},
	{0xE051, "Page Down"},
	{0xE04B, "Left arrow"},
	{0xE04D, "Right arrow"},
	{0xE048, "Up arrow"},
	{0xE050, "Down arrow"},
	{0x3A, "Caps Lock"},
	{0x45, "Num Lock"},
	{0x46, "Scroll Lock"},
	{0x3B, "F1"},
	{0x3C, "F2"},
	{0x3D, "F3"},
	{0x3E, "F4"},
	{0x3F, "F5"},
	{0x40, "F6"},
	{0x41, "F7"},
	{0x42, "F8"},
	{0x43, "F9"},
	{0x44, "F10"},
	{0x57, "F11"},
	{0x58, "F12"},
	{0x02, "1"},
	{0x03, "2"},
	{0x04, "3"},
	{0x05, "4"},
	{0x06, "5"},
	{0x07, "6"},
	{0x08, "7"},
	{0x09, "8"},
	{0x0A, "9"},
	{0x0B, "0"},
	{0x0C, "Hyphen -_"},
	{0x0D, "Equal =+"},
	{0x0E, "Backspace"},
	{0x0F, "Tab"},
	{0x1C, "Enter"},
	{0x29, "Backquote `~"},
	{0x27, "Semicolon ;:"},
	{0x28, "Quote '\""},
	{0x33, "Comma ,<"},
	{0x34, "Period .>"},
	{0x35, "Slash /?"},
	{0x2B, "Backslash \\|"},
	{0x1A, "Left brace [{"},
	{0x1B, "Right brace ]}"},
	{0x53, "Keypad ."},
	{0xE035, "Keypad /"},
	{0x37, "Keypad *"},
	{0x4A, "Keypad -"},
	{0x4E, "Keypad +"},
	{0xE01C, "Keypad Enter"},
	{0x52, "Keypad 0"},
	{0x4F, "Keypad 1"},
	{0x50, "Keypad 2"},
	{0x51, "Keypad 3"},
	{0x4B, "Keypad 4"},
	{0x4C, "Keypad 5"},
	{0x4D, "Keypad 6"},
	{0x47, "Keypad 7"},
	{0x48, "Keypad 8"},
	{0x49, "Keypad 9"},
	{0x39, "Spacebar"},
	{0x1E, "A"},
	{0x30, "B"},
	{0x2E, "C"},
	{0x20, "D"},
	{0x12, "E"},
	{0x21, "F"},
	{0x22, "G"},
	{0x23, "H"},
	{0x17, "I"},
	{0x24, "J"},
	{0x25, "K"},
	{0x26, "L"},
	{0x32, "M"},
	{0x31, "N"},
	{0x18, "O"},
	{0x19, "P"},
	{0x10, "Q"},
	{0x13, "R"},
	{0x1F, "S"},
	{0x14, "T"},
	{0x16, "U"},
	{0x2F, "V"},
	{0x11, "W"},
	{0x2D, "X"},
	{0x15, "Y"},
	{0x2C, "Z"},
	{0x01, "Escape"},
};


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTradeKeysDlg dialog

CTradeKeysDlg::CTradeKeysDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTradeKeysDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTradeKeysDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hLargeIcon = (HICON) ::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
	m_hSmallIcon = (HICON) ::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	m_intMapCount = 0;
	m_bNoColor = FALSE;
	m_pMapArray = NULL;
}

void CTradeKeysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTradeKeysDlg)
	DDX_Control(pDX, IDC_cmdSwap, m_cmdSwap);
	DDX_Control(pDX, IDC_fraKeys, m_fraKeys);
	DDX_Control(pDX, IDC_lstMapTo, m_lstMapTo);
	DDX_Control(pDX, IDC_lstMapFrom, m_lstMapFrom);
	DDX_Control(pDX, IDC_cmdMap, m_cmdMap);
	DDX_Control(pDX, IDC_cmdSave, m_cmdSave);
	DDX_Control(pDX, IDC_cmdUnmap, m_cmdUnmap);
	DDX_Control(pDX, IDC_lstKeys, m_lstKeys);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTradeKeysDlg, CDialog)
	//{{AFX_MSG_MAP(CTradeKeysDlg)
	ON_WM_DESTROY()
	ON_NOTIFY(LVN_GETDISPINFO, IDC_lstKeys, OnGetdispinfolstKeys)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_lstKeys, OnItemchangedlstKeys)
	ON_BN_CLICKED(IDC_cmdMap, OncmdMap)
	ON_BN_CLICKED(IDC_cmdUnmap, OncmdUnmap)
	ON_BN_CLICKED(IDC_cmdAbout, OncmdAbout)
	ON_BN_CLICKED(IDC_cmdLoad, OncmdLoad)
	ON_BN_CLICKED(IDC_cmdSave, OncmdSave)
	ON_BN_CLICKED(IDC_cmdDisable, OncmdDisable)
	ON_BN_CLICKED(IDC_cmdSwap, OncmdSwap)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_lstMapFrom, OnGetdispinfolstMapFrom)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_lstMapFrom, OnItemchangedlstMapFrom)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_lstMapTo, OnItemchangedlstMapTo)
	ON_NOTIFY(NM_SETFOCUS, IDC_lstKeys, OnSetfocuslstKeys)
	ON_BN_CLICKED(IDCANCEL, OnCancel)
	ON_BN_CLICKED(IDOK, OnOK)
	ON_NOTIFY(LVN_KEYDOWN, IDC_lstKeys, OnKeydownlstKeys)
	//}}AFX_MSG_MAP
	ON_NOTIFY(LVN_GETDISPINFO, IDC_lstMapTo, OnGetdispinfolstMapFrom)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_lstKeys, OnCustomDrawlstKeys)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_lstMapFrom, OnCustomDrawlstMap)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_lstMapTo, OnCustomDrawlstMap)
	ON_MESSAGE(TRADEKEYS_VERIFY_ID, OnVerifyID)
	ON_MESSAGE(TRADEKEYS_OPEN_FILE, OnOpenFile)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTradeKeysDlg message handlers

BOOL CTradeKeysDlg::OnInitDialog()
{
	int				iResult,
					iCount;
	CRect			rect;
	LVITEM			lvi;
	CString			strPrompt;
	OSVERSIONINFO	osvi;


	CDialog::OnInitDialog();

	m_bWarnRestart = theApp.GetProfileInt(theApp.m_strSettingSection, "WarnRestart", TRUE);
	m_bNoColor = theApp.GetProfileInt(theApp.m_strSettingSection, "NoColor", FALSE);
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	g_bIsNT = (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT);

	m_imgKeyIcons.Create(IDB_BITMAP1, 16, 0, 0x0000ff00);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hLargeIcon, TRUE);			// Set big icon
	SetIcon(m_hSmallIcon, FALSE);		// Set small icon
	m_lstKeys.InsertColumn(0, "Key", LVCFMT_LEFT, 90, 0);
	m_lstKeys.InsertColumn(1, "Mapped to", LVCFMT_LEFT, 90, 1);
	m_lstKeys.SetImageList(&m_imgKeyIcons, LVSIL_SMALL);
	// If COMCTL32.DLL is version 4.70 or newer,
	if (Check_ComCtl_Version())
	{
		// Set the full row select style for the list controls.
		m_lstKeys.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
		m_lstMapFrom.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
		m_lstMapTo.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	}

	// Read current mapping data from the registry.
	iResult = Read_Map_Data();
	switch (iResult)
	{
	case 0:
		break;
	case 1:
		strPrompt = "Unable to access the registry.";
		break;
	case 2:
		strPrompt = "Unable to access scan code map.";
		break;
	case 3:
		strPrompt = "Scan code map value is the wrong data type.";
		break;
	case 4:
		strPrompt = "Memory allocation error.";
		break;
	case 5:
		strPrompt = "Unable to retrieve scan code map data.";
		break;
	case 6:
		strPrompt = "Scan code map data format is unknown or invalid.";
	}
	if (iResult != 0)
	{
		MessageBox(strPrompt, "TradeKeys error", MB_ICONSTOP);
		EndDialog(IDCANCEL);
		return TRUE;
	}

	// Rearrange the map array, grouping keys in pairs
	// and setting icons/colors for the list controls.
	Arrange_Array();

	// Build the key selection lists.
	m_lstMapFrom.InsertColumn(0, NULL, LVCFMT_LEFT, 100, 0);
	m_lstMapTo.InsertColumn(0, NULL, LVCFMT_LEFT, 100, 0);
	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	lvi.pszText = LPSTR_TEXTCALLBACK;
	lvi.iItem = 0;
	lvi.iSubItem = 0;
	m_intToCount = 0;
	m_intFromCount = 0;
	for (iCount = 0; iCount <  TOTAL_MAP_ENTRIES; iCount++)
	{
		if (!g_bIsNT)
		{
			if (g_MasterTable[iCount].wScanCode > 0xFF)
			{
				continue;
			}
		}
		lvi.lParam = iCount;
		if (iCount > 0)
		{
			lvi.iItem = m_intFromCount;
			m_lstMapFrom.InsertItem(&lvi);
			++m_intFromCount;
		}
		lvi.iItem = m_intToCount;
		m_lstMapTo.InsertItem(&lvi);
		++m_intToCount;
	}
	lvi.iItem = 0;
	lvi.mask = LVIF_STATE;
	lvi.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
	lvi.state = LVIS_SELECTED | LVIS_FOCUSED;
	m_lstMapFrom.SetItem(&lvi);
	m_lstMapTo.SetItem(&lvi);
	m_lstMapFrom.SetColumnWidth(0, LVSCW_AUTOSIZE);
	m_lstMapTo.SetColumnWidth(0, LVSCW_AUTOSIZE);

	// Mark document as "clean".
	m_bDirty = FALSE;

	// Build the mapped keys list.
	if (m_intMapCount > 0)
	{
		// Initialize the LVITEM structure.
		lvi.mask		= LVIF_TEXT | LVIF_IMAGE;
		lvi.iSubItem	= 0;
		lvi.pszText		= LPSTR_TEXTCALLBACK;
		lvi.iImage		= I_IMAGECALLBACK;

		// Add one entry to the list for each element in the array.
		for (iCount = 0; iCount < m_intMapCount; iCount++)
		{
			lvi.iItem = iCount;
			m_lstKeys.InsertItem(&lvi);
		}
		// Select the first item in the list.
		m_lstKeys.SelectExclusive(0);
		// Synchronize the "Map from" and "Map to" list selections.
		Synch_Lists(0);
	}

	// Was there a filename on the command line?
	if (!m_strFileName.IsEmpty())
	{
		// Yes .. try to load the file.
		if (!Load_File(m_strFileName))
			// Display message if it failed.
			AfxMessageBox(	"File load failed.\n\n"
							"List will display mappings (if any) that\n"
							"are currently in effect.", MB_ICONINFORMATION);
	}

	////////////////////////////
	// Set up column widths for the "Mapped keys" list.
	m_lstKeys.SetColumnWidth(0, LVSCW_AUTOSIZE_USEHEADER);
	m_intMinFromColumnWidth = m_lstKeys.GetColumnWidth(0) + 3;
	m_lstKeys.SetColumnWidth(0, m_intMinFromColumnWidth);
	m_lstKeys.SetColumnWidth(1, LVSCW_AUTOSIZE_USEHEADER);
	m_intMinToColumnWidth = m_lstKeys.GetColumnWidth(1);
	Set_Column_Widths();
	Set_Button_States();
	if (theApp.m_pSharedData != NULL)
	{
		theApp.m_pSharedData->hWndMain = m_hWnd;
	}
	return TRUE;
}
// Disable "Esc" to close the dialog.
void CTradeKeysDlg::OnCancel() 
{
	// Any pending changes?
//	if (m_bDirty)
//	{
//		// Yes .. ask user if he really wants to quit.
//		if (AfxMessageBox("Displayed mappings have not been applied.\n"
//			"Do you want to exit anyway?", MB_YESNO | MB_ICONQUESTION) != IDYES)
//			return;
//	}
	CDialog::OnCancel();
}

void CTradeKeysDlg::OnOK()
{
	int		i;
	LONG	lResult;
	HKEY	hKey;
	DWORD	*pData;
	DWORD	dwDisposition;

	// Under NT, the "Apply" button is really the "Cancel" button.
	if (g_bIsNT)
	{
		// Are there any settings to apply?
		if (m_bDirty)
		{
			// Yes ... do it.
			// Build map array.
			pData = new DWORD[m_intMapCount + 4];
			// First two DWORDS must be zero.
			pData[0] = 0;
			pData[1] = 0;
			// Third DWORD holds the number of mappings + 1 for the NULL entry at the end of the list.
			pData[2] = m_intMapCount + 1;
			// Mappings are stored starting with the fourth DWORD.
			for (i = 0; i < m_intMapCount; i++)
			{
				// Of each DWORD, the low word is the new code, the high word is the old code.
				pData[i + 3] = MAKELPARAM(m_pMapArray[i].wNewCode, m_pMapArray[i].wOldCode);
			}
			// Store NULL entry at the end of the array.
			pData[m_intMapCount + 3] = 0;
			// Open the Registry key.
			lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Keyboard Layout", 0, KEY_SET_VALUE, &hKey);
			if (lResult != ERROR_SUCCESS)
			{
				AfxMessageBox("Error opening mapping key.");
				return;
			}
			lResult = RegSetValueEx(hKey, "ScanCode Map", 0, REG_BINARY, (LPBYTE) pData, (m_intMapCount * 4) + 16);
			if (lResult != ERROR_SUCCESS)
			{
				AfxMessageBox("Error writing map data to the registry.");
			}
			else
			{
				m_bDirty = FALSE;
				if (m_bWarnRestart)
				{
					CWarnDlg dlg;
					if (dlg.DoModal() == IDOK)
					{
						if (dlg.m_bNo)
						{
							m_bWarnRestart = FALSE;
							theApp.WriteProfileInt(theApp.m_strSettingSection, "WarnRestart", m_bWarnRestart);
						}
					}
				}
			}
			// Done with the key.
			RegCloseKey(hKey);
			// Done with the data array.
			delete [] pData;
		}
	}
	else
	{
		// For Windows 9X:
		// Reset to default mappings.
		for (i = 0; i < 256; i++)
			g_KeyMappings[i] = i;
		// Apply new mappings from our array.
		for (i = 0; i < m_intMapCount; i++)
		{
			g_KeyMappings[m_pMapArray[i].wOldCode] = (UCHAR) m_pMapArray[i].wNewCode;
		}
		// Make sure the VXD key exists.
		lResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE, VXD_KEY, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition); 
		if (lResult != ERROR_SUCCESS)
		{
			AfxMessageBox("Unable to access the registry");
			return;
		}
		// Write the map table to the Registry.
		lResult = RegSetValueEx(hKey, "KeyMappings", 0, REG_BINARY, g_KeyMappings, 256);
		if (lResult == ERROR_SUCCESS)
		{
			// Also make sure the VxD is set to load.
			lResult = RegSetValueEx(hKey, "StaticVxD", 0, REG_SZ, (LPBYTE) "VKeyMap.VxD", 12);
		}
		// Done with the registry key.
		RegCloseKey(hKey);
		// All data written sucessfully?
		if (lResult == ERROR_SUCCESS)
		{
			// Yes .. give driver a copy of the new mappings.
			Write_Driver();
			m_bDirty = FALSE;
		}
		else
		{
			AfxMessageBox("Error writing to the registry.");
		}
	}
	Set_Button_States();
	CDialog::OnOK();
}

void CTradeKeysDlg::OnDestroy()
{
	if (m_pMapArray != NULL)
	{
		free(m_pMapArray);
		m_pMapArray = NULL;
	}
	DestroyIcon(m_hSmallIcon);
	DestroyIcon(m_hLargeIcon);
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

///////////////////////////////////////////////
// List control notification handlers.

// LVN_GETDISPINFO for the "Map from" and "Map to" lists.
void CTradeKeysDlg::OnGetdispinfolstMapFrom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

	if (pDispInfo->item.mask & LVIF_TEXT)
		pDispInfo->item.pszText = (LPSTR) g_MasterTable[pDispInfo->item.lParam].pszName;
	*pResult = 0;
}

// LVN_GETDISPNFO for the "Mapped keys" list.
void CTradeKeysDlg::OnGetdispinfolstKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

	// Is the control asking for text?
	if (pDispInfo->item.mask & LVIF_TEXT)
	{
		// Yes .. for which column?
		switch (pDispInfo->item.iSubItem)
		{
		case 0:	// "Key" column.
			pDispInfo->item.pszText = m_pMapArray[pDispInfo->item.iItem].pszOldName;
			break;
		case 1: // "Mapped to" column.
			pDispInfo->item.pszText = m_pMapArray[pDispInfo->item.iItem].pszNewName;
			break;
		}
	}
	// Is the control asking for the icon?
	if (pDispInfo->item.mask & LVIF_IMAGE)
	{
		// Yes. (iColor determines both the icon to display and
		// which color to use for the entire item)
		pDispInfo->item.iImage = m_pMapArray[pDispInfo->item.iItem].iColor;
	}
	*pResult = 0;
}

// LVN_ITEMCHANGED from the "Mapped keys" list.
void CTradeKeysDlg::OnItemchangedlstKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMLISTVIEW	pNMListView = (LPNMLISTVIEW) pNMHDR;

	if (pNMListView->uChanged & LVIF_STATE)
	{
		Set_Button_States();
		if (pNMListView->uNewState & LVIS_FOCUSED)
		{
			Synch_Lists(pNMListView->iItem);
		}
	}
	*pResult = 0;
}

// NM_CUSTOMDRAW from the "Mapped keys" list control.
void CTradeKeysDlg::OnCustomDrawlstKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
    LPNMLVCUSTOMDRAW  lplvcd = (LPNMLVCUSTOMDRAW) pNMHDR;

	*pResult = CDRF_DODEFAULT;
	if (m_bNoColor)
		return;
    switch(lplvcd->nmcd.dwDrawStage)
	{
    case CDDS_PREPAINT :
        *pResult = CDRF_NOTIFYITEMDRAW;
		return;

    case CDDS_ITEMPREPAINT:
		{
			LPMAP_ARRAY_ENTRY pRecord;

			pRecord = &m_pMapArray[lplvcd->nmcd.dwItemSpec];
			switch (pRecord->iColor)
			{
			case 0:
				// Green.
				lplvcd->clrText = 0x00008000;
				break;
			case 1:
			case 2:
				// Yes ... set color to blue.
				lplvcd->clrText = 0x00FF0000;
				break;
			case 3:
				// Yes .. set it to red.
				lplvcd->clrText = 0x000000FF;
				break;
			default:
				// No .. set it to black.
				lplvcd->clrText = 0;
			}
			*pResult = CDRF_NEWFONT;
		}
	}

}

// NM_CUSTOMDRAW from the "Map to" and "Map from" lists.
void CTradeKeysDlg::OnCustomDrawlstMap(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int					iColor;
    LPNMLVCUSTOMDRAW	lplvcd = (LPNMLVCUSTOMDRAW) pNMHDR;

	*pResult = CDRF_DODEFAULT;
	if (m_bNoColor)
		return;
    switch(lplvcd->nmcd.dwDrawStage)
	{
    case CDDS_PREPAINT :
        *pResult = CDRF_NOTIFYITEMDRAW;
		return;

    case CDDS_ITEMPREPAINT:
		{
			// Determine which control sent the message
			// and retrieve the color accordingly.
			if (pNMHDR->idFrom == IDC_lstMapFrom)
				iColor = m_intFromColors[lplvcd->nmcd.lItemlParam];
			else
				iColor = m_intToColors[lplvcd->nmcd.lItemlParam];
			switch (iColor)
			{
			case 0:		// Mapped
				// Set color to green.
				lplvcd->clrText = 0x00008000;
				*pResult = CDRF_NEWFONT;
				break;
			case 1:		// Swapped
			case 2:
				// Set color to blue.
				lplvcd->clrText = 0x00FF0000;
				*pResult = CDRF_NEWFONT;
				break;
			case 3:		// Disabled
				// Set color to red.
				lplvcd->clrText = 0x000000FF;
				*pResult = CDRF_NEWFONT;
				break;
			default:	// Anything else
				// Use default color.
				*pResult = CDRF_DODEFAULT;
				return;
			}
		}
	}

}

// LVN_ITEMCHANGED from the "Map from" list.
void CTradeKeysDlg::OnItemchangedlstMapFrom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMLISTVIEW	pNMListView = (LPNMLISTVIEW) pNMHDR;

	if (pNMListView->uChanged & LVIF_STATE)
	{
		if (pNMListView->uNewState & LVIS_SELECTED)
		{
			m_wCodeFrom = g_MasterTable[pNMListView->lParam].wScanCode;
			m_cmdSwap.EnableWindow(!((m_wCodeTo == 0) || (m_wCodeFrom == m_wCodeTo)));
		}
	}
	
	*pResult = 0;
}

// LVN_KEYDOWN from the "Mapped keys" list.
// Enables Ctrl+A to select all items.
void CTradeKeysDlg::OnKeydownlstKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMLVKEYDOWN* pLVKeyDown = (NMLVKEYDOWN*)pNMHDR;

	if (pLVKeyDown->wVKey == 'A')
	{
		if (GetKeyState(VK_CONTROL) & 0x80)
			m_lstKeys.SelectAll();
	}
	*pResult = 0;
}

// LVN_ITEMCHANGED from the "Map to" list.
void CTradeKeysDlg::OnItemchangedlstMapTo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMLISTVIEW	pNMListView = (LPNMLISTVIEW) pNMHDR;

	if (pNMListView->uChanged & LVIF_STATE)
	{
		if (pNMListView->uNewState & LVIS_SELECTED)
		{
			m_wCodeTo = g_MasterTable[pNMListView->lParam].wScanCode;
			m_cmdSwap.EnableWindow(!((m_wCodeTo == 0) || (m_wCodeFrom == m_wCodeTo)));
		}
	}
	*pResult = 0;
}

// NM_SETFOCUS for the "Mapped keys" list.
void CTradeKeysDlg::OnSetfocuslstKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int			iItem;
	POSITION	pos;

	pos = m_lstKeys.GetFirstSelectedItemPosition();
	if (pos != NULL)
	{
		iItem = m_lstKeys.GetNextSelectedItem(pos);
		Synch_Lists(iItem);
	}
	*pResult = 0;
}

///////////////////////////////////
// Command button handlers.
void CTradeKeysDlg::OncmdDisable() 
{
	int		iItem;

	if (Add_Map_To_List(m_wCodeFrom, 0) < 0)
		return;
	// Rearrange the array to group key pairs together
	// and set the pair colors.
	Arrange_Array();
	// Update the list display.
	m_lstKeys.RedrawItems(0, m_intMapCount - 1);
	m_bDirty = TRUE;
	// Find the array element we just added or modified
	iItem = Find_Map(m_wCodeFrom);
	// And select it in the list.
	m_lstKeys.SelectExclusive(iItem);
	Synch_Lists(iItem);
	Set_Button_States();
}

void CTradeKeysDlg::OncmdSwap() 
{
	int		iItem;

	if (Add_Map_To_List(m_wCodeFrom, m_wCodeTo) < 0)
		return;
	if (Add_Map_To_List(m_wCodeTo, m_wCodeFrom) < 0)
		return;
	// Rearrange the array to group key pairs together
	// and set the pair colors.
	Arrange_Array();
	// Update the list display.
	m_lstKeys.RedrawItems(0, m_intMapCount - 1);
	m_bDirty = TRUE;
	// Find the array element we just added or modified
	iItem = Find_Map(m_wCodeFrom);
	// And select it in the list.
	m_lstKeys.SelectExclusive(iItem);
	Synch_Lists(iItem);
	Set_Button_States();
}

void CTradeKeysDlg::OncmdSave() 
{
	int			i;
	CFile		file;
	CString		strFileName,
				strTemp;

	// Prepare the Save dialog.
	CFileDialog	dlg(FALSE,
					".tkm",
					NULL,
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_SHAREAWARE | OFN_NOCHANGEDIR,
					"TradeKeys Map files (*.tkm)|*.tkm||",
					this);

	dlg.m_ofn.lpstrTitle = "Save keyboard map";
	dlg.m_ofn.lpstrInitialDir = m_strSavePath;
	// Launch the dialog; done if user didn't say "OK".
	if (dlg.DoModal() != IDOK)
		return;
	// Get filename from the dialog.
	strFileName = dlg.GetPathName();
	// Strip down to just the path.
	i = strFileName.ReverseFind('\\');
	if (i >= 0)
	{
		strTemp = strFileName.Left(i);
		// Is it different?
		if (strTemp.CompareNoCase(m_strSavePath) != 0)
		{
			// Yes .. update the setting.
			m_strSavePath = strTemp;
			theApp.WriteProfileString(theApp.m_strSettingSection, "SavePath", m_strSavePath);
		}
	}
	// Can file be opened?
	if (file.Open(strFileName, CFile::modeCreate | CFile::shareExclusive | CFile::modeWrite))
	{
		// Yes.
		try
		{
			// Create CArchive & attach it to the file.
			CArchive ar(&file, CArchive::store);
			// Write file header.
			ar << CString("TradeKeys 2.0");
			// Write map count.
			ar << m_intMapCount;
			// Write each array entry.
			for (i = 0; i < m_intMapCount; i++)
			{
				ar << m_pMapArray[i].wNewCode;
				ar << m_pMapArray[i].wOldCode;
			}
			// Close the archive and detach it from the file.
			ar.Close();
		}
		catch (CException *e)
		{
			e->Delete();
			AfxMessageBox("Error creating or accessing CArchive object.");
		}
		// Close the file.
		file.Close();
	}
}

// Presents the About box.
void CTradeKeysDlg::OncmdAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CTradeKeysDlg::OncmdLoad() 
{
	int				iPos;
	CString			strTemp,
					strFileName;

	// Prepare the Load dialog.
	CFileDialog	dlg(TRUE,
					".tkm",
					NULL,
					OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_SHAREAWARE | OFN_NOCHANGEDIR,
					"TradeKeys Map files (*.tkm)|*.tkm||",
					this);

	dlg.m_ofn.lpstrTitle = "Load keyboard map";
	dlg.m_ofn.lpstrInitialDir = m_strSavePath;
	// Launch the dialog. Done if user didn't say "OK".
	if (dlg.DoModal() != IDOK)
		return;
	// Retrieve the fully-qualified filename
	strFileName = dlg.GetPathName();
	// Strip down to just the path.
	iPos = strFileName.ReverseFind('\\');
	if (iPos >= 0)
	{
		strTemp = strFileName.Left(iPos);
		// Is it different?
		if (strTemp.CompareNoCase(m_strSavePath) != 0)
		{
			// Yes .. update the setting.
			m_strSavePath = strTemp;
			theApp.WriteProfileString(theApp.m_strSettingSection, "SavePath", m_strSavePath);
		}
	}
	// Try to load the specified file.
	Load_File(strFileName);
}

// "Unmap" button.
void CTradeKeysDlg::OncmdUnmap()
{
	int			iItem,
				iItemCount,
				iSelectedItemCount,
				*pSelectedItems;
	WORD		wOldCode,
				wNewCode;
	CString		strPrompt;
	POSITION	pos;

	// Are there any items selected in the "Mapped keys" list?
	pos = m_lstKeys.GetFirstSelectedItemPosition();
	if (pos == NULL)
		// No ... nothing to do!
		return;
	
	// Create array for selection list.
	pSelectedItems = new int[m_intMapCount];
	// Get selection index.
	iItem = m_lstKeys.GetNextSelectedItem(pos);
	// Save the codes
	wOldCode = m_pMapArray[iItem].wOldCode;
	wNewCode = m_pMapArray[iItem].wNewCode;
	// Build the selection list.
	iSelectedItemCount = 1;
	pSelectedItems[0] = iItem;
	while (pos != NULL)
	{
		pSelectedItems[iSelectedItemCount] = m_lstKeys.GetNextSelectedItem(pos);
		++iSelectedItemCount;
	}
	if (iSelectedItemCount > 1)
	{
		strPrompt.Format("Are you sure you want to\n"
						"unmap these %i keys?", iSelectedItemCount);
		if (AfxMessageBox(strPrompt, MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) != IDYES)
		{
			delete[] pSelectedItems;
			return;
		}
	}
	for (iItemCount = iSelectedItemCount - 1; iItemCount >= 0; iItemCount--)
	{
		m_lstKeys.DeleteItem(pSelectedItems[iItemCount]);
		Delete_Map_Element(pSelectedItems[iItemCount]);
	}
	delete [] pSelectedItems;
	// Rearrange the array.
	Arrange_Array();
	// Is the list not empty?
	if (m_intMapCount > 0)
	{
		// No .. adjust item index.
		while (iItem >= m_intMapCount)
			--iItem;
		// Is item index valid?
		if (iItem < 0)
			// No ..item.
			iItem = 0;
		m_lstKeys.SelectExclusive(iItem);
		// Set "Map from" and "Map to" list selections accordingy.
		Synch_Lists(iItem);
	}
	Set_Column_Widths();
	// Mark data as "dirty".
	m_bDirty = TRUE;
	// Update controls accordingly.
	m_lstKeys.RedrawItems(0, m_intMapCount -1);
	m_lstMapFrom.RedrawItems(0, m_intFromCount - 1);
	m_lstMapTo.RedrawItems(0, m_intToCount - 1);
	Set_Button_States();
}

// Map a new key (or remap an existing one)
void CTradeKeysDlg::OncmdMap() 
{
	int		iItem;

	// Old and new codes the same?
	if (m_wCodeFrom == m_wCodeTo)
	{
		// Yes .. map key to itself = remove it from the list.
		// Find the key in the list.
		if ((iItem = Find_Map(m_wCodeFrom)) < 0)
			// Nothing to do if it isn't there.
			return;
		// Make sure it's selected.
		m_lstKeys.SelectExclusive(iItem);
		// Then remove it.
		OncmdUnmap();
		return;
	}
	if (Add_Map_To_List(m_wCodeFrom, m_wCodeTo) < 0)
		return;
	// Rearrange the array to group key pairs together
	// and set the pair colors.
	Arrange_Array();
	// Update the list display.
	m_lstKeys.RedrawItems(0, m_intMapCount - 1);
	// Set "Dirty" flag.
	m_bDirty = TRUE;
	// Find the array element we just added or modified
	iItem = Find_Map(m_wCodeFrom);
	// And select it in the list.
	m_lstKeys.SelectExclusive(iItem);
	// Synch key selection lists with the master list.
	Synch_Lists(iItem);
	// Update button states accordingly.
	Set_Button_States();
}



//////////////////////////////////
// Helper functions.



// Adds a new mapping to the document and list using the provided scan codes.
// If mapping already exists, returns the index of the matching item.
// Otherwise, returns index of the new item or -1 if item cannot be added.
int CTradeKeysDlg::Add_Map_To_List(WORD wOldCode, WORD wNewCode)
{
	int		iIndex;
	LVITEM	lvi;

	// Do we already have an entry for the selected key?
	if ((iIndex = Find_Map(wOldCode)) < 0)
	{
		// No ... add new key to the array.
		iIndex = Add_Map_To_Array(wOldCode, wNewCode);
		// Bail if unable to add.
		if (iIndex < 0)
			return -1;
		// Add new entry to the list.
		lvi.iItem = iIndex;
		lvi.iSubItem = 0;
		lvi.mask = LVIF_TEXT | LVIF_IMAGE;
		lvi.pszText = LPSTR_TEXTCALLBACK;
		lvi.iImage = I_IMAGECALLBACK;
		m_lstKeys.InsertItem(&lvi);
		// Make sure it's the only item selected.
		m_lstKeys.SelectExclusive(lvi.iItem);
		m_lstKeys.EnsureVisible(lvi.iItem, FALSE);
	}
	else
	{
		// Yes .. update the existing map.
		m_pMapArray[iIndex].wNewCode = wNewCode;
		// Update pointer to the new key name string.
		m_pMapArray[iIndex].pszNewName = g_MasterTable[Find_Key(wNewCode)].pszName;
	}
	Set_Column_Widths();
	return iIndex;
}

// Sets the selections in the "Map from" and "Map to" lists to
// match the specified selection in the "Mapped keys" list.
void CTradeKeysDlg::Synch_Lists(int iOffset)
{
	LVITEM		lvi;

	// Is the map array empty?
	if (m_intMapCount == 0)
	{
		// Yes .. select the first item in each list.
		lvi.iItem = 0;
		lvi.iSubItem = 0;
		lvi.mask = LVIF_STATE;
		lvi.state = LVIS_SELECTED | LVIS_FOCUSED;
		lvi.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
		m_lstMapFrom.SetItem(&lvi);
		m_lstMapTo.SetItem(&lvi);
		m_lstMapFrom.RedrawItems(0, m_lstMapFrom.GetItemCount() -1);
		m_lstMapTo.RedrawItems(0, m_lstMapTo.GetItemCount() -1);
		m_lstMapFrom.EnsureVisible(0, FALSE);
		m_lstMapTo.EnsureVisible(0, FALSE);
		return;
	}
	// Setup Listview Item structure.
	lvi.mask = LVIF_PARAM;
	lvi.iSubItem = 0;
	// Walk through the "Map from" list.
	for (lvi.iItem = 0; lvi.iItem < m_intFromCount; lvi.iItem++)
	{
		// Retrieve current item's data.
		m_lstMapFrom.GetItem(&lvi);
		// Does it match the current item?
		if (m_pMapArray[iOffset].wOldCode == g_MasterTable[lvi.lParam].wScanCode)
		{
			// Yes .. select the item.
			lvi.mask = LVIF_STATE;
			lvi.state = LVIS_SELECTED | LVIS_FOCUSED;
			lvi.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
			m_lstMapFrom.SetItem(&lvi);
			// Make sure it's visible.
			m_lstMapFrom.EnsureVisible(lvi.iItem, FALSE);
			// Done looking for a match.
			break;
		}
	}
	// Redraw the From list.
	m_lstMapFrom.RedrawItems(0, m_intFromCount - 1);
	// Reset flags for LVITEM structure.
	lvi.mask = LVIF_PARAM;
	// Do the same thing for the "Map to" list.
	for (lvi.iItem = 0; lvi.iItem < m_intToCount; lvi.iItem++)
	{
		m_lstMapTo.GetItem(&lvi);
		if (m_pMapArray[iOffset].wNewCode == g_MasterTable[lvi.lParam].wScanCode)
		{
			lvi.mask = LVIF_STATE;
			lvi.state = LVIS_SELECTED | LVIS_FOCUSED;
			lvi.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
			m_lstMapTo.SetItem(&lvi);
			m_lstMapTo.EnsureVisible(lvi.iItem, FALSE);
			break;
		}
	}
	m_lstMapTo.RedrawItems(0, m_intToCount - 1);
}

// Checks version of COMCTL32.DLL
// Returns TRUE if version is 4.70 or later.
// Returns FALSE if version is older or cannot be determined.
BOOL CTradeKeysDlg::Check_ComCtl_Version()
{
	HRESULT				hResult;
	DLLVERSIONINFO		dvi;		// Structure to hold DLL version info
	HINSTANCE			hDLL;		// Instance handle for COMCTL32.DLL
	DLLGETVERSIONPROC	pFunc;		// Pointer to DllGetVersion() function.

	dvi.cbSize = sizeof(DLLVERSIONINFO);			// Initialize structure.
	hDLL = LoadLibrary("COMCTL32.DLL");				// Attempt to load an instance of COMCTL32.DLL
	if (hDLL == NULL)								// Signal error if failure.
	{
		return FALSE;		// Report failure to caller.
	}
	// Try to get pointer to exported "DllGetVersion" function.
	pFunc = (DLLGETVERSIONPROC) GetProcAddress(hDLL, "DllGetVersion");
	if (pFunc == NULL)		// Report error if function not found.
	{
		FreeLibrary(hDLL);
		return FALSE;		// Report failure to caller.
	}
	hResult = pFunc(&dvi);	// Call DLLGetVersion to fill in the version info structure.
	FreeLibrary(hDLL);		// Done with the COMCTL32.DLL, so release it.
	// Did function call succeed?
	if (SUCCEEDED(hResult))
	{
		// Yes .. test version numbers & return appropriate result.
		if (dvi.dwMajorVersion > 4)
			return TRUE;
		else if (dvi.dwMajorVersion < 4)
			return FALSE;
		else if (dvi.dwMinorVersion >= 70)
			return TRUE;
		else
			return FALSE;
	}
	else
	{
		// No .. indicate failure.
		return FALSE;
	}
}

// Loads the map array from the specified file.
BOOL CTradeKeysDlg::Load_File(LPCTSTR pszFileName)
{
	int					iCount,
						iThis,
						iThat,
						iKeyIndex;
	BOOL				bInvalid;
	LVITEM				lvi;
	LPMAP_ARRAY_ENTRY	pNewArray = NULL;
	LPMAP_ARRAY_ENTRY	pThis;
	CFile				file;
	CString				strTemp;
	CArchive			*ar = NULL;

	// Try to open the file.
	if (file.Open(pszFileName, CFile::shareExclusive | CFile::modeRead))
	{
		// Try to create a CArchive & attach it to the file.
		try
		{
			ar = new CArchive(&file, CArchive::load);
		}
		catch (CException *e)
		{
			// Clean up if CArchive creation failed.
			e->Delete();
			AfxMessageBox("Error creating CArchive object");
			if (ar != NULL)
				delete ar;
			file.Close();
			return FALSE;
		}
		// Read header from file.
		try
		{
			*ar >> strTemp;
		}
		catch (CException *e)
		{
			e->Delete();
			AfxMessageBox("File I/O error.");
			ar->Close();
			file.Close();
			delete ar;
			return FALSE;
		}
		// Is it the correct version?
		if (strTemp != "TradeKeys 2.0")
		{
			// No ... report the error and clean up.
			AfxMessageBox("File is not a valid TradeKeys map.");
			ar->Close();
			file.Close();
			delete ar;
			return FALSE;
		}
		// Read item count.
		try
		{
			*ar >> iCount;
		}
		catch (CException *e)
		{
			e->Delete();
			AfxMessageBox("File I/O error.");
			ar->Close();
			file.Close();
			delete ar;
			return FALSE;
		}
		// Does the file have any records?
		if (iCount > 0)
		{
			// Yes ... allocate new array to hold them.
			pNewArray = (LPMAP_ARRAY_ENTRY) calloc(iCount, sizeof(MAP_ARRAY_ENTRY));
			// Did allocation fail?
			if (pNewArray == NULL)
			{
				// Yes .. report error and clean up.
				AfxMessageBox("Memory allocation error");
				ar->Close();
				delete ar;
				file.Close();
				return FALSE;
			}
			// Read elements from the file.
			try
			{
				for (iThis = 0; iThis < iCount; iThis++)
				{
					*ar >> pNewArray[iThis].wNewCode;
					*ar >> pNewArray[iThis].wOldCode;
				}
			}
			catch (CException *e)
			{
				e->Delete();
				AfxMessageBox("File I/O error.");
				ar->Close();
				file.Close();
				delete ar;
				free(pNewArray);
				return FALSE;
			}
		}
		// Close the archive.
		ar->Close();
		// Delete the CArchive object.
		delete ar;
		// Close the file.
		file.Close();
	}
	else
	{
		// File open failed -- report the error.
		strTemp.Format("Unable to access\n%s.", pszFileName);
		AfxMessageBox(strTemp);
		return FALSE;
	}
	// If we're under Win 9x, check loaded map for extended keys.
	bInvalid = FALSE;
	if ((iCount > 0) && (!g_bIsNT))
	{
		// Walk through the array.
		iThis = 0;
		while(iThis < iCount)
		{
			// Is either scan code for an extended key?
			if (pNewArray[iThis].wOldCode > 0xFF ||
				pNewArray[iThis].wNewCode > 0xFF)
			{
				// Yes .. set flag.
				bInvalid = TRUE;
				// Compact the array to remove the unsupported key.
				iThat = iThis + 1;
				while (iThat < iCount)
				{
					pNewArray[iThat - 1] = pNewArray[iThat];
					++iThat;
				}
				// Update the count.
				--iCount;
			}
			else
			{
				// No .. continue with next element.
				++iThis;
			}
		}
		// Did we have to skip any elements?
		if (bInvalid)
		{
			// Yes .. are there any elements left?
			if (iCount != 0)
			{
				// Yes .. reallocate the array.
				pNewArray = (LPMAP_ARRAY_ENTRY) realloc(pNewArray, iCount * sizeof(MAP_ARRAY_ENTRY));
			}
			strTemp.Format("NOTE: %s\n"
							"contains mappings for one or more extended keys,\n"
							"which are not supported under Windows 95, 98, or ME.\n\n"
							"Those unsupported mappings have not been loaded.\n\n"
							"This does not mean that the file is damaged, only that\n"
							"it was probably saved under Windows 2000 or XP.", pszFileName);
			// Let user know what we did.
			AfxMessageBox(strTemp, MB_ICONINFORMATION);
		}
	}
	// Is the new array empty?
	if (iCount == 0)
	{
		// Yes .. free it.
		free(pNewArray);
		pNewArray = NULL;
	}
	// File has been succesfully loaded into memory.

	// Empty the list control.
	m_lstKeys.DeleteAllItems();
	// If master array is not already empty,
	if (m_intMapCount != 0)
	{
		// Empty it.
		free(m_pMapArray);
		m_pMapArray = NULL;
		m_intMapCount = 0;
	}
	// Did we actually load anything?
	if (iCount > 0)
	{
		bInvalid = FALSE;
		// Yes .. put the new array in place.
		m_intMapCount = iCount;
		m_pMapArray = pNewArray;
		// Set key name pointers and check for invalid scan codes.
		for (iThis = 0; iThis < m_intMapCount; iThis++)
		{
			pThis = &m_pMapArray[iThis];
			iKeyIndex = Find_Key(pThis->wOldCode);
			if (iKeyIndex < 0)
			{
				bInvalid = TRUE;
				Delete_Map_Element(iThis);
				continue;
			}
			pThis->pszOldName = g_MasterTable[iKeyIndex].pszName;
			iKeyIndex = Find_Key(pThis->wNewCode);
			if (iKeyIndex < 0)
			{
				bInvalid = TRUE;
				Delete_Map_Element(iThis);
				continue;
			}
			pThis->pszNewName = g_MasterTable[iKeyIndex].pszName;
		}
		// Did we have to delete any invalid records?
		if (bInvalid)
		{
			strTemp.Format("WARNING: %s\n"
							"is damaged and contains one or more invalid records.\n\n"
							"All valid records (if any) have been loaded successfully.\n\n"
							"After verifying that the displayed mappings are correct,\n"
							"you should re-save the file to repair the damage.", pszFileName);
			AfxMessageBox(strTemp, MB_ICONSTOP);
		}
	}
	// Is there anything left in the array after all that?
	if (m_intMapCount > 0)
	{
		// Yes .. Sort the array and set colors and icons.
		Arrange_Array();
		// Build new list.
		lvi.mask = LVIF_TEXT | LVIF_IMAGE;
		lvi.iSubItem = 0;
		lvi.pszText = LPSTR_TEXTCALLBACK;
		lvi.iImage = I_IMAGECALLBACK;
		for (iThis = 0; iThis < m_intMapCount; iThis++)
		{
			lvi.iItem = iThis;
			m_lstKeys.InsertItem(&lvi);
		}
		// Select the first item in the list.
		m_lstKeys.SelectExclusive(0);
	}
	else
	{
		// No .. make sure the "Map from" and "Map to" lists get redrawn.
		Reset_Colors();
		Synch_Lists(0);
	}
	Set_Column_Widths();
	// Set "dirty" flag; file has been loaded but mapppings
	// have not been applied.
	m_bDirty = TRUE;
	// Update the buttons.
	Set_Button_States();
	return TRUE;
}

// Gets a handle to the key mapping VxD so we can talk to it.
int CTradeKeysDlg::Open_Driver ()
{
	hVxD = CreateFile ("\\\\.\\VKEYMAP", 0, 0, NULL, CREATE_NEW, 0, NULL);

	if (hVxD == INVALID_HANDLE_VALUE)
		return GetLastError();
	else
		return 0;
}

// Closes the VxD handle after we're done with it.
int CTradeKeysDlg::Close_Driver ()
{
	CloseHandle (hVxD);
	
	return 0;
}

// Updates the VxD with current key map data.
int CTradeKeysDlg::Write_Driver ()
{
	ULONG ulBytesReturned;
	int rc = 0;

	if (Open_Driver())
	{
		int what = ::MessageBox (::GetDesktopWindow(), 
			"Keyboard driver is not yet loaded. Do you want to reboot your system to load it?",
			"TradeKeys",
			MB_YESNO | MB_SYSTEMMODAL);

		if (what == IDYES)
		{
			ExitWindowsEx (EWX_REBOOT, 0);
		}
	}
	else
	{
		rc = DeviceIoControl (hVxD, 
			IOCTL_NEW_MAPPINGS,
			g_KeyMappings,
			sizeof (g_KeyMappings),
			NULL, 0,
			&ulBytesReturned, NULL);

		Close_Driver();
	}
	
	return rc;
}

// Reorders the map array so that swapped keys are listed together.
// Also sets appropriate colors and icons for the list controls.
void CTradeKeysDlg::Arrange_Array()
{
	int				iAnchor,
					iScan,
					iNext,
					iFind,
					iMove;
	BOOL			bFound;
	MAP_ARRAY_ENTRY temp;

	// Reset default icons and colors.
	Reset_Colors();
	// Sort the list alpahbetically by name.
	qsort(m_pMapArray, m_intMapCount, sizeof(MAP_ARRAY_ENTRY), Compare_Old_Key_Names);
	// Now group swapped keys together.
	iAnchor = 0;
	iScan = 0;
	while (iAnchor < m_intMapCount)
	{
		// Get index of next element.
		iNext = iAnchor + 1;
		// Done if past the end of the array.
		if (iNext == m_intMapCount)
			break;
		// Are these two elements a pair?
		if ((m_pMapArray[iAnchor].wNewCode == m_pMapArray[iNext].wOldCode) &&
			(m_pMapArray[iAnchor].wOldCode == m_pMapArray[iNext].wNewCode))
		{
			// Yes ... set color of each item.
			m_pMapArray[iAnchor].iColor = 1;
			m_pMapArray[iNext].iColor = 2;
			// Move past this pair.
			iAnchor += 2;
			continue;
		}
		// Begin search for a pair to the anchor element.
		bFound = FALSE;
		// Start with the element after the current pair.
		for (iScan = iNext + 1; iScan < m_intMapCount; iScan++)
		{
			// Is current element a pair to the anchor element?
			if ((m_pMapArray[iScan].wOldCode == m_pMapArray[iAnchor].wNewCode) &&
				(m_pMapArray[iScan].wNewCode == m_pMapArray[iAnchor].wOldCode))
			{
				// Yes .. set flag.
				bFound = TRUE;
				// Save the matching element.
				temp = m_pMapArray[iScan];
				// Make a hole for it.
				for (iMove = iScan; iMove > iNext; iMove--)
					m_pMapArray[iMove] = m_pMapArray[iMove -1];
				// Put the matching element in the hole.
				m_pMapArray[iNext] = temp;
				// Set pair color.
				m_pMapArray[iAnchor].iColor = 1;
				m_pMapArray[iNext].iColor = 2;
				// Move to the next item after this pair.
				iAnchor = iNext + 1;
				break;
			}
		}
		// Was a matching entry found?
		if (!bFound)
		{
			// No .. advance anchor to next element.
			++iAnchor;
		}
	}
	// Transfer color info to the master table.
	for (iAnchor = 0; iAnchor < m_intMapCount; iAnchor++)
	{
		for (iFind = 1; iFind < TOTAL_MAP_ENTRIES; iFind++)
		{
			if (m_pMapArray[iAnchor].wOldCode == g_MasterTable[iFind].wScanCode)
			{
				m_intFromColors[iFind] = m_pMapArray[iAnchor].iColor;
				break;
			}
		}
		for (iFind = 1; iFind < TOTAL_MAP_ENTRIES; iFind++)
		{
			if (m_pMapArray[iAnchor].wNewCode == g_MasterTable[iFind].wScanCode)
			{
				m_intToColors[iFind] = m_pMapArray[iAnchor].iColor;
				break;
			}
		}
	}
}

// Reads existing key mappings from the registry.
// Return values:
//	0 = No Error.
//	1 = Unable to access the registry.
//  2 = Unable to read ScanCode Map value.
//  3 = ScanCode Map value exists but contains the wrong data type.
//	4 = Memory allocation error.
//	5 = Unable to retrieve map data.
//	6 = Map data format is invalid.
//	7 = Unknown scan code encountered.
int CTradeKeysDlg::Read_Map_Data()
{
	int		iResult = 0;
	UINT	iCount;
	HKEY	hKey;
	LONG	lResult;
	DWORD	dwCount;
	DWORD	*pData = NULL;
	DWORD	*pMap;
	DWORD	dwType;
	DWORD	dwDataSize;
	DWORD	dwThis;
	WORD	wOldCode;
	WORD	wNewCode;

	if (g_bIsNT)
	{
		// Open the parent key.
		lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Keyboard Layout", 0, KEY_READ, &hKey);
		if (lResult != ERROR_SUCCESS)
			return 1;
		// Get information about the "ScanCode Map" value.
		lResult = RegQueryValueEx(hKey, "ScanCode Map", NULL, &dwType, NULL, &dwDataSize);
		// Was there an error?
		if (lResult != ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			// Did the key not exist?
			if (lResult == 2)
				// Yes ... no keys are remapped.
				return 0;
			else
				// No ... report error.
				return 2;
		}
		// Is the data in REG_BINARY format?
		if (dwType != REG_BINARY)
		{
			// No .. report the error.
			RegCloseKey(hKey);
			return 3;
		}
		// Must be at least 16 bytes (DWORD version, DWORD flag, DWORD count, and DWORD for at least one map value)
		if (dwDataSize < 16)
		{
			RegCloseKey(hKey);
			return 6;
		}
		// Allocate buffer to hold the data.
		pData = (DWORD*) malloc(dwDataSize);
		// Report error if allocation failed.
		if (pData == NULL)
		{
			RegCloseKey(hKey);
			return 4;
		}
		// Read the data from the key.
		lResult = RegQueryValueEx(hKey, "ScanCode Map", NULL, &dwType, (LPBYTE) pData, &dwDataSize);
		// Done with the key.
		RegCloseKey(hKey);
		// Report error if unable to retrieve key data.
		if (lResult != ERROR_SUCCESS)
		{
			free(pData);
			return 5;
		}
		// Retrieve the count from the array.
		dwCount = pData[2];
		// Count must be at least one.
		if (dwCount < 1)
		{
			free(pData);
			return 6;
		}
		// Must have enough data to allow for array count.
		if ( ((dwCount * 4) + 12) != dwDataSize)
		{
			free(pData);
			return 6;
		}
		// Point to beginning of key mappings.
		pMap = &pData[3];
		// Is last entry zero?
		if (pMap[dwCount - 1] != 0)
		{
			// No ... format is invalid.
			free(pData);
			return 6;
		}
		// Adjust count to allow for final null entry.
		--dwCount;
		// Loop through the array.
		for (dwThis = 0; dwThis < dwCount; dwThis++)
		{
			// Get the old and new scan codes.
			wOldCode = HIWORD(pMap[dwThis]);
			wNewCode = LOWORD(pMap[dwThis]);
			if (Add_Map_To_Array(wOldCode, wNewCode) < 0)
			{
				iResult = 4;
				break;
			}
		}
		free(pData);
		return iResult;
	}
	else
	{
		g_KeyMappings[0] = 0;
		// Open the parent key.
		lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, VXD_KEY, 0, KEY_READ, &hKey);
		if (lResult != ERROR_SUCCESS)
			goto SetDefault;
		// Get information about the "ScanCode Map" value.
		lResult = RegQueryValueEx(hKey, "KeyMappings", NULL, &dwType, NULL, &dwDataSize);
		// Was there an error?
		if (lResult != ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			goto SetDefault;
		}
		// Is the data in REG_BINARY format?
		if (dwType != REG_BINARY)
		{
			// No .. report the error.
			RegCloseKey(hKey);
			goto SetDefault;
		}
		// Must be exactly 256 bytes (DWORD version, DWORD flag, DWORD count, and DWORD for at least one map value)
		if (dwDataSize != 256)
		{
			RegCloseKey(hKey);
			goto SetDefault;
		}
		// Read the data from the key.
		lResult = RegQueryValueEx(hKey, "KeyMappings", NULL, &dwType, g_KeyMappings, &dwDataSize);
		// Done with the key.
		RegCloseKey(hKey);
		// Report error if unable to retrieve key data.
		if (lResult != ERROR_SUCCESS)
		{
			// Yes ... revert to default - no keys are remapped.
			goto SetDefault;
		}
		for (iCount = 0; iCount < 256; iCount++)
		{
			if (g_KeyMappings[iCount] != (UCHAR) iCount)
			{
				wOldCode = iCount;
				wNewCode = g_KeyMappings[iCount];
				Add_Map_To_Array(wOldCode, wNewCode);
			}
		}
		return 0;
	}
SetDefault:
	// Yes ... revert to default - no keys are remapped.
	for (iCount = 0; iCount < 256; iCount++)
		g_KeyMappings[iCount] = (UCHAR) iCount;
	return 0;
}

// Adds a new element to the map array.
// Returns -1 on error, otherwise the index of the new item.
int CTradeKeysDlg::Add_Map_To_Array(WORD wOldCode, WORD wNewCode)
{
	int					iIndex;
	LPMAP_ARRAY_ENTRY	pNewTable = NULL;

	// Add new item to the end of the array.
	iIndex = m_intMapCount;
	// Reallocate the array.
	pNewTable = (LPMAP_ARRAY_ENTRY) realloc(m_pMapArray, (m_intMapCount + 1) * sizeof(MAP_ARRAY_ENTRY));
	// Did allocation fail?
	if (pNewTable == NULL)
		// Yes .. report the error.
		return -1;
	// Save new (possibly changed) array pointer.
	m_pMapArray = pNewTable;
	// Add new element to the end of the array.
	m_pMapArray[iIndex].wOldCode = wOldCode;
	// Store pointer to key name string to speed up text retrieval
	// for the list control, and make the qsort function more efficient.
	m_pMapArray[iIndex].pszOldName = g_MasterTable[Find_Key(wOldCode)].pszName;
	m_pMapArray[iIndex].wNewCode = wNewCode;
	m_pMapArray[iIndex].pszNewName = g_MasterTable[Find_Key(wNewCode)].pszName;
	// Update array size.
	++m_intMapCount;
	// Return the index of the element we added.
	return iIndex;
}

// Looks up a scan code in the master table and
// returns its table index.
// Returns -1 if matching scan code is not found.
int CTradeKeysDlg::Find_Key(WORD wCode)
{
	int iIndex;

	for (iIndex = 0; iIndex < TOTAL_MAP_ENTRIES; iIndex++)
	{
		if (wCode == g_MasterTable[iIndex].wScanCode)
			return iIndex;
	}
	return -1;
}

// Deletes the specified element from the map array
// and compacts it to close the gap.
void CTradeKeysDlg::Delete_Map_Element(int iIndex)
{
	int					iCount;
	LPMAP_ARRAY_ENTRY	pNewTable;

	// Is there more than one element in the array?
	if (m_intMapCount > 1)
	{
		// Yes .. move all elements down to fill the hole
		// left by the one we're deleting.
		for (iCount = iIndex; iCount < (m_intMapCount - 1); iCount++)
		{
			m_pMapArray[iCount] = m_pMapArray[iCount + 1];
		}
	}
	// Adjust the count.
	--m_intMapCount;
	// Is the array empty?
	if (m_intMapCount == 0)
	{
		// Yes .. free its memory.
		free(m_pMapArray);
		m_pMapArray = NULL;
	}
	else
	{
		// No .. reallocate it accordingly.
		pNewTable = (LPMAP_ARRAY_ENTRY) realloc(m_pMapArray, m_intMapCount * sizeof(MAP_ARRAY_ENTRY));
		m_pMapArray = pNewTable;
	}
}

// Find the specified source scan code in the map array.
// Returns -1 if no matching code found.
int CTradeKeysDlg::Find_Map(WORD wCode)
{
	int	iIndex;

	if (m_intMapCount == 0)
		return -1;
	for (iIndex = 0; iIndex < m_intMapCount; iIndex++)
	{
		if (m_pMapArray[iIndex].wOldCode == wCode)
			return iIndex;
	}
	return -1;
}

// Enables/Disables controls based on list selections
// and/or the "dirty" state of the map data.
void CTradeKeysDlg::Set_Button_States()
{
	// Enable the Swap button only if "<disabled>" is not 
	// selected in the "Map to" list, or both lists don't have the
	// same key selected.
	m_cmdSwap.EnableWindow(!((m_wCodeTo == 0) || (m_wCodeFrom == m_wCodeTo)));
	// Is the "Mapped keys" list empty?
	if (m_lstKeys.GetItemCount() == 0)
	{
		// Yes .. disable the Unmap button.
		m_cmdUnmap.EnableWindow(FALSE);
		// And we're done.
		return;
	}
	// List is not empty....
	// Disable the "Unmap" button if there's no selection in the list.
	m_cmdUnmap.EnableWindow(m_lstKeys.GetFirstSelectedItemPosition() != NULL);
}

// Sizes columns in the "Mapped keys" list to fit either
// their contents or their headers, whichever is wider.
void CTradeKeysDlg::Set_Column_Widths()
{
	int	iWidth;

	// Size the "Key" column to fit its widest element.
	m_lstKeys.SetColumnWidth(0, LVSCW_AUTOSIZE);
	// Get its current width.
	iWidth = m_lstKeys.GetColumnWidth(0);
	// Is it wider than the header?
	if (iWidth < m_intMinFromColumnWidth)
		// Yes .. size to fit the header instead.
		m_lstKeys.SetColumnWidth(0, m_intMinFromColumnWidth);
	else
		m_lstKeys.SetColumnWidth(0, iWidth + 3);
	// Do the same for the "Mapped to" column.
	m_lstKeys.SetColumnWidth(1, LVSCW_AUTOSIZE);
	iWidth = m_lstKeys.GetColumnWidth(1);
	if (iWidth < m_intMinToColumnWidth)
		m_lstKeys.SetColumnWidth(1, m_intMinToColumnWidth);
}

// Comparison function for qsort
int CTradeKeysDlg::Compare_Old_Key_Names(const void* p1, const void* p2)
{
	const LPMAP_ARRAY_ENTRY r1 = (const LPMAP_ARRAY_ENTRY) p1;
	const LPMAP_ARRAY_ENTRY r2 = (const LPMAP_ARRAY_ENTRY) p2;

	return stricmp(r1->pszOldName, r2->pszOldName);
};

// Resets all icons and colors to their defaults.
void CTradeKeysDlg::Reset_Colors()
{
	int iIndex;

	if (m_intMapCount > 0)
	{
		for (iIndex = 0; iIndex < m_intMapCount; iIndex++)
		{
			if (m_pMapArray[iIndex].wNewCode == 0)
				m_pMapArray[iIndex].iColor = 3;
			else
				m_pMapArray[iIndex].iColor = 0;
		}
	}
	m_intFromColors[0] = 4;
	m_intToColors[0] = 3;
	for (iIndex = 1; iIndex < TOTAL_MAP_ENTRIES; iIndex++)
	{
		m_intFromColors[iIndex] = 4;
		m_intToColors[iIndex] = 4;
	}
}

/////////////////////////////////////
// Private message handlers

// TRADEKEYS_VERIFY_ID, used for multiple-instance handling.
long CTradeKeysDlg::OnVerifyID(WPARAM, LPARAM)
{
	return TRADEKEYS_APP_ID;
}

// TRADEKEYS_OPEN_FILE, posted by a second instance when
// launched with a filename on the command line.
long CTradeKeysDlg::OnOpenFile(WPARAM, LPARAM)
{
	if (theApp.m_pSharedData != NULL)
		Load_File(theApp.m_pSharedData->pszFileName);
	return 0L;
}


