// TradeKeysDlg.h : header file
//

// TradeKeys Version 2.0
// Copyright  2003 Ziff Davis Media, Inc. All rights reserved.
// First published in PC Magazine, US Edition, January 14, 2003.
// Written by Gregory A. Wolking

#if !defined(AFX_TRADEKEYSDLG_H__8D257A3A_38CA_4EE2_B9D0_AF1972F0F4D6__INCLUDED_)
#define AFX_TRADEKEYSDLG_H__8D257A3A_38CA_4EE2_B9D0_AF1972F0F4D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define TOTAL_MAP_ENTRIES	103
#include "TKListCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CTradeKeysDlg dialog

class CTradeKeysDlg : public CDialog
{
// Construction
public:

	// Functions
	CTradeKeysDlg(CWnd* pParent = NULL);	// standard constructor

	// Variables
	CString m_strSavePath;
	CString m_strFileName;

// Dialog Data
	//{{AFX_DATA(CTradeKeysDlg)
	enum { IDD = IDD_TRADEKEYS_DIALOG };
	CButton	m_cmdSwap;
	CButton	m_fraKeys;
	CListCtrl	m_lstMapTo;
	CListCtrl	m_lstMapFrom;
	CButton	m_cmdMap;
	CButton	m_cmdSave;
	CButton	m_cmdUnmap;
	TKListCtrl	m_lstKeys;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTradeKeysDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTradeKeysDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnGetdispinfolstKeys(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnItemchangedlstKeys(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OncmdMap();
	afx_msg void OncmdUnmap();
	afx_msg void OncmdAbout();
	afx_msg void OncmdLoad();
	afx_msg void OncmdSave();
	afx_msg void OncmdDisable();
	afx_msg void OncmdSwap();
	afx_msg void OnGetdispinfolstMapFrom(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedlstMapFrom(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedlstMapTo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetfocuslstKeys(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeydownlstKeys(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	afx_msg void OnCustomDrawlstKeys(NMHDR* pNMHDR, LRESULT* pResult); 
	afx_msg void OnCustomDrawlstMap(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg long OnVerifyID(WPARAM, LPARAM);
	afx_msg long OnOpenFile(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()

protected:
	void Reset_Colors(void);
	BOOL m_bNoColor;
	// Member variables
	int					m_intMinFromColumnWidth;
	int					m_intMinToColumnWidth;
	int					m_intMapCount;
	int					m_intToCount;
	int					m_intFromCount;
	int					m_intToColors[TOTAL_MAP_ENTRIES];
	int					m_intFromColors[TOTAL_MAP_ENTRIES];
	WORD				m_wCodeTo;
	WORD				m_wCodeFrom;
	BOOL				m_bDirty;
	BOOL				m_bWarnRestart;
	HICON				m_hLargeIcon;
	HICON				m_hSmallIcon;
	CImageList			m_imgKeyIcons;
	LPMAP_ARRAY_ENTRY	m_pMapArray;

	// Member functions.
	int Find_Map(WORD wCode);
	int Find_Key(WORD wCode);
	int Read_Map_Data();
	int Add_Map_To_List(WORD wOldCode, WORD wNewCode);
	int Add_Map_To_Array(WORD wOldCode, WORD wNewCode);
	int Open_Driver();
	int Close_Driver();
	int Write_Driver();
	BOOL Check_ComCtl_Version();
	BOOL Load_File(LPCTSTR pszFileName);
	void Set_Column_Widths();
	void Synch_Lists(int iOffset);
	void Arrange_Array(void);
	void Set_Button_States();
	void Delete_Map_Element(int iIndex);
	static int Compare_Old_Key_Names(const void* p1, const void* p2);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRADEKEYSDLG_H__8D257A3A_38CA_4EE2_B9D0_AF1972F0F4D6__INCLUDED_)
