// setup2.cpp : Defines the class behaviors for the application.
//

// TradeKeys Version 2.0
// Copyright  2003 Ziff Davis Media, Inc. All rights reserved.
// First published in PC Magazine, US Edition, January 14, 2003.
// Written by Gregory A. Wolking

#include "stdafx.h"
#include "setup2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetup2App

BEGIN_MESSAGE_MAP(CSetup2App, CWinApp)
	//{{AFX_MSG_MAP(CSetup2App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetup2App construction

CSetup2App::CSetup2App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSetup2App object

CSetup2App theApp;

/////////////////////////////////////////////////////////////////////////////
// CSetup2App initialization

BOOL CSetup2App::InitInstance()
{
	int		iResult;
	OSVERSIONINFO osvi;

	// Get OS version.
	osvi.dwOSVersionInfoSize = sizeof(osvi);
	GetVersionEx(&osvi);
	// Is this Windows NT?
	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		// Yes .. give message and bail.
		::MessageBox(NULL, "This setup utility is not required under Windows NT", "TradeKeys Setup", MB_ICONINFORMATION);
		return FALSE;
	}

	// Can we access the VxD?
	if (OpenDriver())
	{
		// Yes. Ask user if he wants to launch the program.
		iResult = ::MessageBox(NULL, "Do you want to launch TradeKeys now?", "TradeKeys Setup", MB_YESNO);
		// Terminate setup, if it's still running.
		EndSetup();
		// Did user say "yes"?
		if (iResult == IDYES)
		{
			// Launch the program.
			WinExec("Tradekeys.exe", SW_SHOWNORMAL);
		}
		// And we're out of here.
		return FALSE;
	}
	// No .. VxD is not available ask user if he wants to restart now.
	iResult = ::MessageBox (::GetDesktopWindow(), 
							"You must restart your system to complete the installation\n"
							"Do you want to do this now?",
	"TradeKeys",
	MB_YESNO | MB_SYSTEMMODAL);
	// Terminate Setup if it's still running.
	EndSetup();
	// Did user say "Yes"?
	if (iResult == IDYES)
		// Yes .. restart the system.
		ExitWindowsEx(EWX_REBOOT, 0);
	// All done.
	return FALSE;
}

// Determines if VxD is loaded in current config.
int CSetup2App::OpenDriver()
{
	HANDLE hVxD = CreateFile ("\\\\.\\VKEYMAP", 0, 0, NULL, CREATE_NEW, 0, NULL);

	if (hVxD == INVALID_HANDLE_VALUE)
	{
		return FALSE;
	}
	else
	{
		CloseHandle(hVxD);
		return TRUE;
	}
}

// Looks for the Setup Wizard's final page. If found, clicks its Finish button.
void CSetup2App::EndSetup()
{
	int		iCount,
			iCtrlID;
	HWND	hWnd,
			hWndButton;

	// Retry 4 times.
	for (iCount = 0; iCount < 4; iCount++)
	{
		// Look for the wizard page.
		hWnd = FindWindow("TWizardForm", "Setup - Tradekeys");
		// Not found?
		if (hWnd == NULL)
			// No .. wait 1/4 second & try again.
			Sleep(250);
	}
	// Found the form?
	if (hWnd != NULL)
	{
		// Yes .. find its "Finish" button.
		hWndButton = ::FindWindowEx(hWnd, NULL, "TButton", "&Finish");
		// Found the button?
		if (hWndButton != NULL)
		{
			// Yes .. get its control identifier.
			iCtrlID = ::GetDlgCtrlID(hWndButton);
			// Post message to click the button.
			::PostMessage(hWnd, WM_COMMAND, (WPARAM) iCtrlID, (LPARAM) hWndButton);
		}
	}
}
